import os
import sys
from tkinter import *
from tkinter import ttk
from tkinter import filedialog
from tkinter import messagebox

EffDict = {
    #   "効果名"        :       [["設定１","デフォルト設定"],["設定２","デフォルト設定"],["設定３","デフォルト設定"]], 各設定3つ目に-1でチェックボックス
    "座標": [["X", 0.0], ["Y", 0.0], ["Z", 0.0]],
    "拡大率": [["拡大率", 100.00], ["X", 100.00], ["Y", 100.00]],
    "透明度": [["透明度", 0.0]],
    "回転": [["X", 0.0], ["Y", 0.0], ["Z", 0.0]],
    "リサイズ": [["拡大率", 100.00], ["X", 100.00], ["Y", 100.00], ["補間なし", 0, -1], ["ドット数でサイズ指定", 0, -1]],
    "反転": [["上下反転", 0, -1], ["左右反転", 0, -1], ["輝度反転", 0, -1], ["色相反転", 0, -1], ["透明度反転", 0, -1]],

    "色調補正": [["明るさ", 100.0], ["ｺﾝﾄﾗｽﾄ", 100.0], ["色相", 0.0], ["輝度", 100.0], ["彩度", 100.0], ["飽和する", 0, -1]],
    "クリッピング": [["上", 0], ["下", 0], ["左", 0], ["右", 0], ["中心の位置を変更", 0, -1]],
    "クロマキー": [["色相範囲", 24], ["彩度範囲", 96], ["境界補正", 1], ["色彩補正", 0, -1], ["透過補正", 0, -1], ["color_yc", "cf010008b3fe"], ["status", 1]],
    # とりあえず青色透過。デフォ設定は0000000000(未設定)とかだったはず。
    "縁取り": [["サイズ", 3], ["ぼかし", 10], ["color", 000000], ["file", ""]],
    "マスク": [["X", 0.0], ["Y", 0.0], ["回転", 0.00], ["サイズ", 100], ["縦横比", 0.0], ["ぼかし", 0], ["マスクの反転", 0, -1], ["元のサイズに合わせる", 0, -1], ["type", 2], ["name", ""], ["mode", 0]],
    "放射ブラー": [["範囲", 20.0], ["X", 0], ["Y", 0], ["サイズ固定", 0, -1]],
    "方向ブラー": [["範囲", 20], ["角度", 50.0], ["サイズ固定", 0, -1]],
    "振動": [["X", 10], ["Y", 10], ["Z", 0], ["周期", 1], ["ランダムに強さを変える", 1, -1], ["複雑に振動", 0, -1]],
    "ミラー": [["透明度", 0.0], ["減衰", 0.0], ["境目調整", 0], ["中心の位置を変更", 1, -1], ["type", 1]],
    # type ミラー方向 上：0 下:1 左:2 右:3 中心位置変更のデフォは0
    "ラスター": [["横幅", 100], ["高さ", 100], ["周期", 1.00], ["縦ラスター", 0], ["ランダム振幅", 0]],
    "波紋": [["中心X", 0], ["中心Y", 0], ["幅", 30.0], ["高さ", 15.0], ["速度", 150], ["num", 0], ["interval", 0], ["add", 0]],
    "ディスプレイスメントマップ": [["param0", 0.0], ["param1", 0.0], ["X", 0.0], ["Y", 0.0], ["回転", 0.00], ["サイズ", 200], ["縦横比", 0.0], ["ぼかし", 5], ["元のサイズに合わせる", 0], ["type", 1], ["name", ""], ["mode", 0], ["calc", 0]],
    "色ずれ": [["ずれ幅", 5], ["角度", 0.0], ["強さ", 100], ["type", 0]],
    "アニメーション効果": [["track0", 0.00], ["track1", 0.00], ["track1", 0.00], ["track2", 0.00], ["track3", 0.00], ["check0", 0], ["type", 0], ["filter", 0], ["name", ""], ["param", ""]],
}

MyDict = {
    # 基本設定
    "fps":   60,
    "RPPPath":   "test.rpp",
    "EXOPath":   "test.exo",
    "SrcPath":   "C:\\Users\\USER\\Documents\\ytpmv_script\\movie.mp4",  # ファイルパス。絶対パスが必要。
    "SrcPosition":   1,  # 再生位置
    "SrcRate":   100,  # 再生速度
    "IsAlpha":   0,  # アルファチャンネルを読み込む
    "IsLoop":   0,  # ループ再生
    "X":   0.0,  # x座標
    "Y":   0.0,  # y座標
    "Z":   0.0,  # z座標
    "Size":   100.0,  # 拡大率
    "Rotation":   0.0,  # 回転
    "Alpha":   0.0,
    "Blend":   0,  # 合成モード

    # エフェクト設定 SettingEffで追加する。
    "Effect":   [
        #   ["EffName",["ConfName1","Conf"],["ConfName2","Conf"]],
    ],
    "EffNum": 0,  # 現時点で追加されているパラメータ数（GUI用）
    "EffCount": 0,  # エフェクト数（GUI用）
    "EffCbNum": 0,  # パラメータ　チェックボックスの数

    # 独自設定
    "IsFlipHEvenObj": 0,  # 偶数オブジェクトを左右反転するか
    "IsAddFilterAsMediaObj": 0,  # 動画ファイルとしてでなく
}

XDict = {
    "移動なし": "",
    "直線移動": 1,
    "加減速移動": 103,
    "曲線移動": 2,
    "瞬間移動": 3,
    "中間点無視": 4,
    "移動量指定": 5,
    "ランダム": 6,
    "反復移動": 8,
    "補完移動": "15@補間移動",
    "回転": "15@回転,100",
    "スクリプト(終了値,15@スクリプト名@設定)": ""
}


def EXOAddEff(MyDict, ItemCount):
    count = 1
    EXOEffects = ""
    for eff in MyDict["Effect"]:
        EXOEffects += "\n["+str(ItemCount)+"." + \
            str(count)+"]\n_name="+str(eff[0])
        for x in range(1, len(eff)):
            EXOEffects += "\n"+str(eff[x][0])+"="+str(eff[x][1])
        count += 1
    return EXOEffects


def SettingEffCUI():
    # CUI用基本設定
    ans = input("RPPのファイル名(相対パス可): ")
    MyDict["RPPPath"] = ans
    ans = input("EXOのファイル名: ")
    MyDict["EXOPath"] = ans + ".exo"
    ans = input("動画素材を適用するかメディアオブジェクトとしてフィルタのみを追加するか[動画素材:0/フィルタのみ:1]")
    MyDict["IsAddFilterAsMediaObj"] = int(ans)
    if MyDict["IsAddFilterAsMediaObj"] == 0:
        ans = input("素材のファイル名(絶対パスのみ): ")
        MyDict["SrcPath"] = ans
    ans = input("EXOを読み込むAviutlのプロジェクトのfps: ")
    MyDict["fps"] = int(ans)
    ans = input("左右反転をしますか？[y:1/n:0]: ")
    MyDict["IsFlipHEvenObj"] = int(ans)
    # 今後合成モードとかの設定を可能にする（GUIを作る場合）

    # CUI用フィルタ追加設定
    effcount = 0
    while True:
        ans1 = input("フィルタ効果を追加しますか？[y/n]: ")
        if ans1 == "n":
            break
        elif ans1 == "y":
            ans2 = input("設定するフィルタ効果を入力 (hで選択可能なフィルタ効果を表示): ")
            if ans2 == "h":
                print(EffDict.keys())
            elif ans2 in EffDict:
                print("\nメモ：パラメータを変化させる際は開始点,終点,移動方法のように設定してください。\n例：0.00,100.00,1\n移動方法について\n直線移動 : 1\n加減速移動 : 103\n曲線移動 : 2\n.tra : 15@スクリプト名@設定番号\n")
                MyDict["Effect"].append([])
                MyDict["Effect"][effcount].append(ans2)
                for eff in EffDict[ans2]:
                    eff[1] = input(
                        str(eff[0]) + " (デフォルト:"+str(eff[1])+") (同じフォーマットで入力してね) : ")
                    MyDict["Effect"][effcount].append(eff)
                effcount += 1


def main():

    bf = 0  # アイテム一つ前の最終フレーム
    layer = 1  # オブジェクトのあるレイヤー（RPP上で複数トラックある場合は別レイヤーに配置する）
    MediaItemsP = []
    MediaItemsL = []

    # EXOの設定
    EXO = "[exedit]\nwidth="+str(1280)+"\nheight="+str(720)+"\nrate="+str(
        60)+"\nscale=1\nlength=10914\naudio_rate=44100\naudio_ch=2"
    ItemCount = 0
    exo_1 = "\n["  # ItemCount
    exo_2 = "]\nstart="  # StartFrame
    exo_3 = "\nend="  # EndFrame
    exo_4 = "\nlayer="  # layer
    exo_4_2 = "\ngroup=1\noverlay=1\nclipping=0\ncamera=0\n["  # Itemcount
    exo_5 = ".0]\n_name=動画ファイル\n再生位置="+str(MyDict["SrcPosition"])+"\n再生速度="+str(MyDict["SrcRate"]) +                   \
        "\nループ再生="+str(MyDict["IsLoop"])+"\nアルファチャンネルを読み込む=" + \
        str(MyDict["IsAlpha"])+"\nfile="+str(MyDict["SrcPath"])
    # この間にエフェクトの設定
    exo_6 = "\n["  # ItemCount
    # exo_7 ItemCountによる分岐のため後のループ内で記述
    exo_7 = ""

    exo_eff = ""  # エフェクト設定用、先に宣言だけしておく。ItemCountを必要とするから後のループ内で処理

    # RPPからのPOSITIOとLENGTHの読み込み。すべて<ITEMの次、３行後にあるものとする。
    with open(MyDict["RPPPath"], mode='r', encoding='CP932', errors='replace') as f:
        RPP = f.readlines()
        for index in range(len(RPP)):
            if RPP[index].find("<ITEM") != -1:
                if RPP[index+1].find("POSITION") != -1 and RPP[index+3].find("LENGTH") != -1:
                    MediaItemsP.append(
                        float(RPP[index+1].split("POSITION ")[1][:-1]))
                    MediaItemsL.append(
                        float(RPP[index+3].split("LENGTH ")[1][:-1]))
                else:
                    print("異常:RPPが変")
    # オブジェクト最初のフレームと長さの計算
    for index in range(len(MediaItemsL)):
        # EXO+=exo_1+str(ItemCount)+exo_2+exo_3+exo_4+str(ItemCount)+exo_5+exo_6+str(ItemCount)+exo_7
        FramePosition = round(MediaItemsP[index]*int(MyDict["fps"])+1)
        FrameLength = round(MediaItemsL[index] * int(MyDict["fps"]))
        if FramePosition == bf:  # 一つ前のオブジェクトとフレームがかぶらないようにする処理
            FramePosition = FramePosition+1
            FrameLength = FrameLength-1
        if FramePosition - bf == 2 and bf != 0:  # 一つ前のオブジェクトの間に1フレームの空きがある場合の処理
            FramePosition = FramePosition-1
            FrameLength = FrameLength + 1
        if FramePosition < bf:
            bf = 0
            layer = layer+1
        bf = FramePosition + FrameLength - 1
        exo_eff = ""
        # エフェクトを追加している場合の設定
        if len(MyDict["Effect"]) != 0:
            exo_eff = EXOAddEff(MyDict, ItemCount)
        # 左右反転を有効にしている場合の処理
        if int(MyDict["IsFlipHEvenObj"]) == 1 and ItemCount % 2 == 0 and int(MyDict["IsAddFilterAsMediaObj"]) == 0:  # 動画ファイル適用 左右反転あり
            exo_eff += "\n[" + str(ItemCount) + "." + str(len(MyDict["Effect"]) + 1) + \
                "]\n_name=反転\n上下反転=0\n左右反転=1\n輝度反転=0\n色相反転=0\n透明度反転=0"
            exo_7 = "." + str(len(MyDict["Effect"])+2)+"]\n_name=標準描画\nX="+str(
                MyDict["X"])+"\nY="+str(MyDict["Y"])+"\nZ="+str(MyDict["Z"])+"\n拡大率="+str(MyDict["Size"])+"\n透明度="+str(MyDict["Alpha"]) + \
                "\n回転=" + str(MyDict["Rotation"]) + \
                "\nblend=" + str(MyDict["Blend"])
            EXO = (EXO+exo_1+str(ItemCount)+exo_2+str(FramePosition)+exo_3+str(FramePosition+FrameLength -
                                                                               1) + exo_4+str(layer)+exo_4_2+str(ItemCount)+exo_5+exo_eff+exo_6+str(ItemCount)+exo_7)
        elif int(MyDict["IsAddFilterAsMediaObj"]) == 0 and (int(MyDict["IsFlipHEvenObj"]) == 0 or ItemCount % 2 != 0):
            # 動画ファイル適用 左右反転なし
            exo_7 = "." + str(len(MyDict["Effect"]) + 1) + "]\n_name=標準描画\nX=" + str(MyDict["X"]) + "\nY=" + str(MyDict["Y"]) + "\nZ=" + str(
                MyDict["Z"]) + "\n拡大率=" + str(MyDict["Size"]) + "\n透明度=" + str(MyDict["Alpha"]) + "\n回転=" + str(MyDict["Rotation"]) + "\nblend=" + str(MyDict["Blend"])
            EXO = (EXO+exo_1+str(ItemCount)+exo_2+str(FramePosition)+exo_3+str(FramePosition+FrameLength -
                                                                               1) + exo_4 + str(layer) + exo_4_2 + str(ItemCount) + exo_5 + exo_eff + exo_6 + str(ItemCount) + exo_7)
        elif int(MyDict["IsAddFilterAsMediaObj"]) == 1 and (int(MyDict["IsFlipHEvenObj"]) == 0 or ItemCount % 2 != 0):
            # フィルタのみの場合 左右反転なし
            exo_4_2 = "\ngroup=1\noverlay=1"
            # 何も効果がかかっていないとエラー吐くので（多分）とりあえず座標0,0,0を掛けておく
            exo_5 = "\n["+str(ItemCount)+".0]\n_name=座標\nX=0.0\nY=0.0\nZ=0.0"
            EXO = (EXO+exo_1+str(ItemCount)+exo_2+str(FramePosition)+exo_3+str(FramePosition+FrameLength -
                                                                               1) + exo_4 + str(layer) + exo_4_2 + exo_5 + exo_eff)
        elif int(MyDict["IsFlipHEvenObj"]) == 1 and ItemCount % 2 == 0 and int(MyDict["IsAddFilterAsMediaObj"]) == 1:
            # フィルタのみの場合 左右反転あり
            exo_4_2 = "\ngroup=1\noverlay=1"
            exo_5 = "\n["+str(ItemCount)+".0]\n_name=座標\nX=0.0\nY=0.0\nZ=0.0"
            exo_eff += "\n[" + str(ItemCount) + "." + str(len(MyDict["Effect"]) + 1) + \
                "]\n_name=反転\n上下反転=0\n左右反転=1\n輝度反転=0\n色相反転=0\n透明度反転=0"
            EXO = (EXO+exo_1+str(ItemCount)+exo_2+str(FramePosition)+exo_3+str(FramePosition+FrameLength -
                                                                               1) + exo_4 + str(layer) + exo_4_2 + exo_5 + exo_eff)

        ItemCount = ItemCount + 1

    with open(MyDict["EXOPath"], mode='w', encoding='shift_jis') as f:
        f.write(EXO)
        messagebox.showinfo("正常終了", "多分正常に生成されました")


def RPPSelelctBtn():  # 参照ボタン
    Ftype = [("REAPERプロジェクトファイル", "*.rpp")]
    Dir = os.path.abspath(os.path.dirname(__file__))
    filepath = filedialog.askopenfilename(filetypes=Ftype, initialdir=Dir)
    file1.set(filepath)


def SelectSrc():  # 素材選択
    Ftype = [("動画ファイル", "*")]
    Dir = os.path.abspath(os.path.dirname(__file__))
    filepath = filedialog.askopenfilename(filetypes=Ftype, initialdir=Dir)
    file4.set(filepath)


def EXOSaveBtn():  # EXO保存ボタン
    Ftype = [("Aviutlオブジェクトファイル", "*.exo")]
    Dir = os.path.abspath(os.path.dirname(__file__))
    filepath = filedialog.asksaveasfilename(
        initialdir=Dir, title="EXOファイル保存場所の選択", filetypes=Ftype)
    file2.set(filepath)


# 動的なエフェクト設定生成
# 参考：https://qiita.com/nnahito/items/41be8e02a6ebc91386e7
hLabel = []  # ラベルのハンドル格納
hLabel2 = []  # ラベル実体
hEntryS = []  # Entry 開始点
hEntryE = []  # Entry 終点
hEntryX = []  # Entry 移動方法
hEntrySE = []  # Entry実体 開始点
hEntryEE = []  # Entry実体 終点
hEntryXCb = []  # コンボボックス実体 移動方法
hCheckBox = []  # チェックボックス用
hCheckBoxCb = []  # チェックボックス実体


def AddEffect():
    hLabel.append(StringVar())
    hLabel[MyDict["EffCount"]+MyDict["EffNum"]].set(v2.get())
    b = ttk.Label(
        frame6, textvariable=hLabel[MyDict["EffCount"]+MyDict["EffNum"]])
    b.grid(row=MyDict["EffCount"]+MyDict["EffNum"] +
           MyDict["EffCbNum"], column=1)
    hLabel2.append(b)
    MyDict["Effect"].append([])
    MyDict["Effect"][MyDict["EffCount"]].append(v2.get())
    MyDict["EffCount"] += 1
    # EffDict[v2.get()]回分ループ
    for n in range(len(EffDict[v2.get()])):
        if EffDict[v2.get()][n][-1] == -1:
            hCheckBox.append(StringVar())
            hCheckBox[MyDict["EffCbNum"]].set(0)
            hCheckBoxCb.append(ttk.Checkbutton(
                frame6,
                padding=0,
                text=EffDict[v2.get()][n][0],
                onvalue=1,
                offvalue=0,
                variable=hCheckBox[MyDict["EffCbNum"]]))
            hCheckBoxCb[MyDict["EffCbNum"]].grid(
                row=MyDict["EffNum"] + MyDict["EffCount"] + MyDict["EffCbNum"], column=1, sticky=(W))
            MyDict["EffCbNum"] += 1
        else:
            hLabel.append(StringVar())
            hLabel[MyDict["EffNum"]+MyDict["EffCount"]
                   ].set(EffDict[v2.get()][n][0])
            b = ttk.Label(
                frame6, textvariable=hLabel[MyDict["EffNum"]+MyDict["EffCount"]])
            b.grid(row=MyDict["EffNum"] + MyDict["EffCount"]+MyDict["EffCbNum"],
                   column=0, padx=5)
            hLabel2.append(b)
            hEntryS.append(StringVar())
            hEntrySE.append(ttk.Entry(
                frame6, textvariable=hEntryS[MyDict["EffNum"]], width=5))
            hEntrySE[MyDict["EffNum"]].grid(
                row=MyDict["EffNum"] + MyDict["EffCount"] + MyDict["EffCbNum"], column=1, padx=5)
            hEntrySE[MyDict["EffNum"]].insert(END, EffDict[v2.get()][n][1])
            hEntryX.append(StringVar())
            hEntryXCb.append(ttk.Combobox(
                frame6, textvariable=hEntryX[MyDict["EffNum"]]))
            hEntryXCb[MyDict["EffNum"]]['values'] = list(XDict.keys())
            hEntryXCb[MyDict["EffNum"]].set("移動なし")
            hEntryXCb[MyDict["EffNum"]].grid(
                row=MyDict["EffNum"] + MyDict["EffCount"]+MyDict["EffCbNum"], column=2, padx=5)

            hEntryE.append(StringVar())
            hEntryEE.append(ttk.Entry(
                frame6, textvariable=hEntryE[MyDict["EffNum"]], width=5))
            hEntryEE[MyDict["EffNum"]].grid(
                row=MyDict["EffNum"] + MyDict["EffCount"]+MyDict["EffCbNum"], column=3, padx=5)
            MyDict["EffNum"] += 1


def DelEffect():  # 効果パラメータ入力画面破棄
    for n in range(len(hLabel)):
        hLabel2[n].grid_forget()
    for n in range(len(hEntryS)):
        hEntrySE[n].destroy()
        hEntryEE[n].destroy()
        hEntryXCb[n].destroy()
    for n in range(len(hCheckBoxCb)):
        hCheckBoxCb[n].destroy()
    MyDict["Effect"] = []
    MyDict["EffCount"] = 0
    MyDict["EffNum"] = 0
    hLabel.clear()
    hLabel2.clear()
    hEntryS.clear()
    hEntryE.clear()
    hEntryX.clear()
    hEntrySE.clear()
    hEntryEE.clear()
    hEntryXCb.clear()
    hCheckBox.clear()
    hCheckBoxCb.clear()


def Run():
    MyDict["RPPPath"] = file1.get()
    MyDict["EXOPath"] = file2.get()
    MyDict["IsAddFilterAsMediaObj"] = v1.get()
    MyDict["SrcPath"] = file4.get()
    MyDict["fps"] = file5.get()
    MyDict["IsFlipHEvenObj"] = v3.get()
    if MyDict["RPPPath"] == "" or MyDict["EXOPath"] == "" or MyDict["fps"] == "":
        messagebox.showinfo("エラー", "値を入力して実行")
        return 0
    count = MyDict["EffCount"]
    runcount = 0
    runcountcb = 0
    eff = ""
    for i in range(0, int(count)):
        # runcount += 1
        del MyDict["Effect"][i][1:]
        for x in range(len(EffDict[MyDict["Effect"][i][0]])):
            if EffDict[MyDict["Effect"][i][0]][x][-1] != -1:  # チェックボックスでない場合
                if hEntryX[runcount].get() == "移動なし":  # 移動なしの場合
                    eff = [EffDict[MyDict["Effect"][i][0]][x][0],
                           str(hEntryS[runcount].get())]
                    MyDict["Effect"][i].append(eff)
                else:  # 移動ありの場合
                    if str(hEntryE[runcount].get()) == "":
                        messagebox.showinfo("エラー", "値を入力して実行")
                        return 0
                    eff = [EffDict[MyDict["Effect"][i][0]][x][0],
                           str(hEntryS[runcount].get())+","+str(hEntryE[runcount].get())+","+str(XDict[hEntryX[runcount].get()])]
                    MyDict["Effect"][i].append(eff)
                runcount += 1
            elif EffDict[MyDict["Effect"][i][0]][x][-1] == -1:
                eff = [EffDict[MyDict["Effect"][i][0]][x][0],
                       str(hCheckBox[runcountcb].get())]
                MyDict["Effect"][i].append(eff)
                runcountcb += 1
    main()


if __name__ == '__main__':
    # root
    root = Tk()
    root.title('RPPtoEXO')
    root.columnconfigure(1, weight=1)

    LFrame = ttk.Frame(root)
    LFrame.grid(row=0, column=0)
    RFrame = ttk.Frame(root)
    RFrame.grid(row=0, column=1)
    # そのうちスクロールウィンドウに対応したい（やりかたがわからない）

    # Frame1 RPP選択
    frame1 = ttk.Frame(LFrame, padding=10)
    frame1.grid(row=0, column=0, sticky=(N))
    button1 = ttk.Button(frame1, text=u'参照', command=RPPSelelctBtn)
    button1.grid(row=0, column=2)
    s1 = StringVar()
    s1.set('.RPP : ')
    label1 = ttk.Label(frame1, textvariable=s1)
    label1.grid(row=0, column=0)
    file1 = StringVar()
    file1_entry = ttk.Entry(frame1, textvariable=file1, width=50)
    file1_entry.grid(row=0, column=1)
    frame1.rowconfigure(0, weight=1)

    # Frame2 EXO指定
    frame2 = ttk.Frame(LFrame, padding=10)
    frame2.grid(row=1, column=0)
    button2 = ttk.Button(frame2, text=u'参照', command=EXOSaveBtn)
    button2.grid(row=1, column=2)
    s2 = StringVar()
    s2.set('.EXO : ')
    label2 = ttk.Label(frame2, textvariable=s2)
    label2.grid(row=1, column=0)
    file2 = StringVar()
    file2_entry = ttk.Entry(frame2, textvariable=file2, width=50)
    file2_entry.grid(row=1, column=1)

    # Frame3 IsAddFilterAsMediaObj IsFlipHEvenObj FPS
    frame3 = ttk.Frame(LFrame, padding=10)
    frame3.grid(row=2, column=0)
    v1 = StringVar()
    v1.set(0)
    cb1 = ttk.Checkbutton(
        frame3,
        padding=5,
        text='フィルタのみを追加する',
        onvalue=1,
        offvalue=0,
        variable=v1)
    cb1.grid(row=0, column=0, sticky=(W))

    s5 = StringVar()
    s5.set('FPS : ')
    label5 = ttk.Label(frame3, textvariable=s5)
    label5.grid(row=0, column=3, sticky=(W+E))
    file5 = StringVar()
    file5_entry = ttk.Entry(frame3, textvariable=file5, width=3)
    file5_entry.grid(row=0, column=4, sticky=(W + E))
    file5_entry.insert(END, "60")
    v3 = StringVar()
    v3.set(0)
    cb2 = ttk.Checkbutton(
        frame3,
        padding=5,
        text='左右反転',
        onvalue=1,
        offvalue=0,
        variable=v3)
    cb2.grid(row=0, column=1, sticky=(W))

    # Frame4 動画素材選択
    frame4 = ttk.Frame(LFrame, padding=10)
    frame4.grid(row=3, column=0)
    button4 = ttk.Button(frame4, text=u'参照', command=SelectSrc)
    button4.grid(row=3, column=2)
    s4 = StringVar()
    s4.set('素材 : ')
    label4 = ttk.Label(frame4, textvariable=s4)
    label4.grid(row=3, column=0, sticky=(W))
    file4 = StringVar()
    file4_entry = ttk.Entry(frame4, textvariable=file4, width=50)
    file4_entry.grid(row=3, column=1)

    # Frame5 エフェクト追加/削除
    frame5 = ttk.Frame(LFrame, padding=10)
    frame5.grid(row=4, column=0)
    v2 = StringVar()
    cb = ttk.Combobox(frame5, textvariable=v2)
    cb['values'] = list(EffDict.keys())
    cb.set("座標")
    cb.grid(row=0, column=0)
    button5 = ttk.Button(frame5, text=u'+', command=AddEffect)
    button5.grid(row=0, column=1)
    button6 = ttk.Button(frame5, text=u'効果のクリア', command=DelEffect)
    button6.grid(row=0, column=2)

    # Frame6
    frame6 = ttk.Frame(RFrame, padding=10, borderwidth=3)
    frame6.grid()

    # Frame7実行
    frame7 = ttk.Frame(LFrame, padding=(0, 5))
    frame7.grid(row=5, column=0)
    button6 = ttk.Button(frame7, text='実行', command=Run)
    button6.grid()

    root.mainloop()
